Redmine - Defect #42815

Limit available locales to those defined by Redmine itself no longer works
2025-06-02 21:46 - Marius BALTEANU
Category: 118n Estimated time: 0.00 hour
Resolution: Fixed Affected version:

Description

The change made in #38529 no longer works, Redmine loads available languages also from plugins or gems in the current trunk.

The issue can be reproduce by adding the following gem:

-—— a/Gemfile
+++ b/Gemfile
@@ -19,6 +19,7 Q@@ gem 'rack', '>= 3.1.3"

gem "stimulus-rails", "~> 1.3"
gem "importmap-rails", "~> 2.0"
gem 'commonmarker', '~> 2.3.0'
+gem "doorkeeper-il8n", "~> 5.2"

and then run the test
. B
Failure:
Redmine: :I18nTest#test_locales_validness [test/unit/lib/redmine/il8n_test.rb:208]:
Expected: 50
Actual: 54

I'm not sure which change caused this issue and | didn't test yet on 5.1-stable branch.

Related issues:
Related to Redmine - Patch #38529: Limit available locales to those defined b... Closed

Associated revisions

Revision 23829 - 2025-06-11 21:48 - Marius BALTEANU

Fix limit available locales to those defined by Redmine itself (#42815).

Revision 23833 - 2025-06-11 22:10 - Marius BALTEANU
Merge r23829 from trunk to 6.0-stable (#42815).

Revision 23834 - 2025-06-11 22:10 - Marius BALTEANU
Merge r23829 from trunk to 5.1-stable (#42815).

History

#1 - 2025-06-02 21:48 - Marius BALTEANU

- File 0001-Extract-available_locales-from-Implementation-module.patch added

The attach patch that extracts available_locales from the module Implementation seems to fix the issue; all tests pass.

Please ignore the change in the Gemfile; it is only for testing purposes.

#2 - 2025-06-02 22:02 - Marius BALTEANU
- File 0002-Drop-Redmine-118n-Backend.new-custom-backend.patch added
Looking at the code, I'm not sure that we need the custom backend anymore, the available locales can be loaded only from the locales files provided
by Redmine directly in config/application.rb.

All tests pass with the attached patch that completely removes the custom backed.

#3 - 2025-06-03 08:00 - Holger Just

| very much like the idea of the second patch!

However, I'm a bt conflicted if we should monkey-patch the "core" 118n::Backend::Simple class and forcibly include other modules there. It may be
cleaner if we would retain our custom backend, even if it's just an "empty" subclass with some includes. The i18n gem recommends to patch the

118n::Backend::Simple in its documentation a lot though, so they might be okay with it and commit to keeping mostly stable internal interfaces...

In any case though, if you do want to keep your approach of using 118n::Backend::Simple directly, is it deliberate that you did not also include the
::118n::Backend::Fallbacks module into 118n::Backend::Simple in your second patch?

#4 - 2025-06-04 08:12 - Marius BALTEANU

Holger Just wrote in #note-3:

| very much like the idea of the second patch!

However, I'm a bt conflicted if we should monkey-patch the "core" 118n::Backend::Simple class and forcibly include other modules there. It may
be cleaner if we would retain our custom backend, even if it's just an "empty" subclass with some includes. The i18n gem recommends to patch
the [18n::Backend::Simple in its documentation a lot though, so they might be okay with it and commit to keeping mostly stable internal
interfaces...

That was my initial plan too, but then | saw the documentation.
In any case though, if you do want to keep your approach of using 118n::Backend::Simple directly, is it deliberate that you did not also include the

::118n::Backend::Fallbacks module into 118n::Backend::Simple in your second patch?

I chose to simply not include it because from my understanding, the config option (config.i18n.fallbacks = true) from
source:trunk/config/application.rb#l 60 is doing the same thing, it fallsback to :en if a translation is missing. Also, the test test_fallback from
source:trunk/test/unit/lib/redmine/i18n_test.rb is passing.

#5 - 2025-06-11 12:52 - Holger Just
Marius BALTEANU wrote in #note-4:

Holger Just wrote in #note-3:

However, I'm a bt conflicted if we should monkey-patch the "core" 118n::Backend::Simple class and forcibly include other modules there. It
may be cleaner if we would retain our custom backend, even if it's just an "empty" subclass with some includes. The i18n gem recommends
to patch the 118n::Backend::Simple in its documentation a lot though, so they might be okay with it and commit to keeping mostly stable
internal interfaces...

That was my initial plan too, but then | saw the documentation.
Turns out, that is more or less also what Rails does. In that case, just including the module seems to be the accepted and intended way to enable
this.
In any case though, if you do want to keep your approach of using 118n::Backend::Simple directly, is it deliberate that you did not also

include the ::118n::Backend::Fallbacks module into 118n::Backend::Simple in your second patch?

| chose to simply not include it because from my understanding, the config option (config.i18n.fallbacks = true) from
source:trunk/config/application.rb#L 60 is doing the same thing, it fallsback to :en if a translation is missing. Also, the test test_fallback from
source:trunk/test/unit/lib/redmine/i18n_test.rb is passing.

| see. | was not aware how much Rails actually offers here via configuration. Still seems a little selective, but oh well... As such, | agree that enabling
config.i18n.fallbacks = true is the way to go here.

#6 - 2025-06-11 21:37 - Marius BALTEANU
- Related to Patch #38529: Limit available locales to those defined by Redmine itself added

#7 - 2025-06-11 21:53 - Marius BALTEANU

- Status changed from New to Resolved
- Assignee set to Marius BALTEANU
- Target version changed from 6.1.0 to 5.1.9

- Resolution set to Fixed

| have committed the first patch and | will merge it to all stable branches since the issue is present on all of them.

Holger, thanks again for you review! I've opened #42859 for refactoring.

#8 - 2025-06-11 22:10 - Marius BALTEANU

- Status changed from Resolved to Closed

Merged to stable branches.

Files
0001-Extract-available_locales-from-Implementation-module.patch ~ 1.71 KB 2025-06-02 Marius BALTEANU
0002-Drop-Redmine-I118n-Backend.new-custom-backend.patch 2.55 KB 2025-06-02 Marius BALTEANU
